//
//	STELSOCK	(SSL Telnet Socket)
//
//	Copyright (C) 1996,1997 NEC Corporation
//	All rights reserved.
//  Authos(s): Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
//

//	    $Archive: /sotools/stelsock/Auth.c $
//			$Revision: 5 $
//			$Date: 97/05/15 1:02p $
static char VssID[] = "$Header: /sotools/stelsock/Auth.c 5     97/05/15 1:02p Mizukosi $";

//
//	Functions:
//		DoSSLTelnet
//		RecvTelnetCmd
//

#include	<windows.h>
#include	<winsock.h>
#include	<stdio.h>

#include	"ssl.h"
#include	"stelsock.h"
#include	"auth.h"
#include	"globals.h"


////////////////////////////////////////////////////////////////
//
//	SSL telnet negotiation
//
//		** Limited telnet applications **
//
int DoSSLTelnet(SOCKET s)
{
	unsigned char buf[128];
	int		ret;
	BOOL	bSSL_Listed;

x_OutputDebugString("DoSSLTelnet\n");

	// Receive first 3 bytes.
	// It is important to use MSG_PEEK option.
	if (RecvTelnetCmd(s, buf, 3, MSG_PEEK) &&
		buf[0] == IAC &&
		buf[1] == DO &&
		buf[2] == AUTHENTICATION){

		ret = recv(s, buf, 3, 0);		// Flush Buffer


#if 0
		// IAC WONT AUTHENTICATION
x_OutputDebugString("\n# IAC WONT AUTHENTICATION #####\n");
		buf[0] = IAC;
		buf[1] = WONT;
		buf[2] = AUTHENTICATION;
		ret = send(s, buf, 3, 0);
		return FALSE;
#endif


x_OutputDebugString("\n# 1");

		// Send "IAC WILL AUTHENTICATION" to server.
		buf[0] = IAC;
		buf[1] = WILL;
		buf[2] = AUTHENTICATION;
		ret = send(s, buf, 3, 0);


		// IAC SB AUTHENTICATION SEND TYPE_SSL ... NULL IAC SE
		if (RecvTelnetCmd(s, buf, 4, 0) &&
			buf[0] == IAC &&
			buf[1] == SB  &&
			buf[2] == AUTHENTICATION &&
			buf[3] == SEND){

			// AUTHENTICATION type matching
			bSSL_Listed = FALSE;
			do {
				if (!RecvTelnetCmd(s, buf, 1, 0))
					return FALSE;
				if (buf[0] == TYPE_SSL)
					bSSL_Listed = TRUE;
			} while (buf[0] != 0);

			if (!RecvTelnetCmd(s, buf, 2, 0) ||
				buf[0] != IAC ||
				buf[1] != SE){
				return FALSE;
			}

			if (!bSSL_Listed)
				return FALSE;

			// IAC SB AUTHENTICATION IS TYPE_SSL
			// AUTH_WHO_CLIENT|AUTH_HOW_ONE_WAY AUTH_SSL_START IAC SE
			buf[0] = IAC;
			buf[1] = SB;
			buf[2] = AUTHENTICATION;
			buf[3] = IS;
			buf[4] = TYPE_SSL;
			buf[5] = 0;
			buf[6] = AUTH_SSL_START;
			buf[7] = IAC;
			buf[8] = SE;
			ret = send(s, buf, 9, 0);

x_OutputDebugString("\n# 2");

		} else {
x_OutputDebugString("false\n");
			return FALSE;
		}

		// IAC SB AUTHENTICATION REPLY TYPE_SSL
		// AUTH_WHO_CLIENT|AUTH_HOW_ONE_WAY AUTH_SSL_ACCEPT IAC SE
		if (RecvTelnetCmd(s, buf, 9, 0) &&
			buf[0] == IAC &&
			buf[1] == SB &&
			buf[2] == AUTHENTICATION &&
			buf[3] == REPLY &&
			buf[4] == TYPE_SSL &&
			buf[5] == 0 &&
			buf[6] == AUTH_SSL_ACCEPT &&
			buf[7] == IAC &&
			buf[8] == SE){

x_OutputDebugString("true\n");
			// SSL telnet negotiation was completed.
			return TRUE;

		} else {
x_OutputDebugString("false\n");
			return FALSE;
		}
		

	} else {
x_OutputDebugString("false\n");
		return FALSE;
	}
}


/////////////////////////////////////////////////////////////
//
//	Receive Telnet Command
//
int RecvTelnetCmd(SOCKET s, char *buf, int len, int flag)
{
	int  ret, i;

	i = 0;
	do {
		ret = recv(s, buf+i, len, flag);

		if (ret == 0 || ret == SOCKET_ERROR)
			return FALSE;

		len -= ret;
		i   += ret;

	} while (len);

	return TRUE;
}
